package Banco.RWLock;
/*
 * Conta.java
 *
 * Created on 17 de Fevereiro de 2006, 16:33
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
import java.util.concurrent.locks.*;
/**
 *
 * @author Frank
 */
public class Conta {
    
    private double saldo = 0;
    private ReadWriteLock lock = new ReentrantReadWriteLock();
    
    /** Creates a new instance of Conta */
    public Conta(double saldo) {
        this.saldo = saldo;
        System.out.println("Conta criada. Saldo inicial: R$" + saldo);
    }
    
    public double getSaldo() {
        lock.readLock().lock();
        try {
            return saldo;
        } finally {
            lock.readLock().unlock();
        }
    }
    
    public void setSaldo(double saldo) {
        lock.writeLock().lock();
        try {
            this.saldo = saldo;
        } finally {
            lock.writeLock().unlock();
        }
    }
    
    public  double debitarValor(double valor) {
        lock.writeLock().lock();
        try {
            if (this.saldo < valor) {
                System.out.println("Saldo insuficiente para saque.");
                return -1;
            } else {
                this.saldo -= valor;
                return this.saldo;
            }
        } finally {
            lock.writeLock().unlock();
        }
    }
}